globales
  numero: entero;
fin

funcion min(a, b: entero): entero
es
  secuencia
    si a < b entonces
      devuelve a;
    si_no
      devuelve b;
    fin
  fin

funcion max(a, b: entero): entero
es
  secuencia
    si a > b entonces
      devuelve a;
    si_no
      devuelve b;
    fin
  fin

funcion mcd(m, n: entero): entero
es
  locales
    menor, mayor, resto: entero;
  fin
  secuencia
    menor:= llama min(m,n);
    mayor:= llama max(m,n);
    resto:= mayor % menor;
    si resto = 0 entonces
      devuelve menor;
    si_no
      devuelve llama mcd(menor, resto);
    fin
  fin

funcion comparacion(a, b: entero): entero
es
  secuencia
    si b = 0 entonces
      devuelve 0;
    si_no
      si a = 0 entonces
        devuelve 1;
      si_no
        devuelve llama comparacion(a-1, b-1);
      fin
    fin
  fin

funcion bits(n: entero): entero
es
  secuencia
    si n <= 1 entonces
      devuelve 1;
    si_no
      devuelve 1 +  llama bits(n / 2);
    fin
  fin

funcion hanoi(n, inicial, final: entero): entero
es
  locales
    libre: entero;
  fin
  secuencia
      si n = 1 entonces
      secuencia
           escribe "Mover disco superior de aguja "; escribe inicial; escribe " a "; escribe final; nl;
      fin
      si_no
      secuencia      
        si inicial != 1 entonces
          si final != 1 entonces
            libre := 1;
          si_no
            si inicial != 2 entonces
              si final != 2 entonces
                  libre := 2;
              si_no
                libre := 3;
              fin
            si_no
              libre := 3;
            fin
          fin
        si_no
          si inicial != 2 entonces
            si final != 2 entonces
              libre := 2;
            si_no
          libre := 3;
                fin
          si_no
             libre := 3;
          fin    
        fin

          numero := llama hanoi(n-1, inicial, libre);
        escribe "Mover disco superior de aguja "; escribe inicial; escribe " a "; escribe final; nl;
        numero := llama hanoi(n-1, libre, final);
      fin
    fin
    devuelve 0;
  fin
  
funcion hanoi2(n, inicial, final, libre: entero): entero
es
  secuencia
    si n = 1 entonces
      secuencia
        escribe "Mover disco superior de aguja "; escribe inicial; escribe " a "; escribe final; nl;
         devuelve 1;
      fin
    si_no
      secuencia
        numero := llama hanoi2(n-1, inicial, libre, final);
        escribe "Mover disco superior de aguja "; escribe inicial; escribe " a "; escribe final; nl;
        devuelve llama hanoi2(n-1, libre, final, inicial);
      fin
    fin
    devuelve 0;
  fin

secuencia
  escribe "##### MCD #####"; nl;
  escribe llama mcd(1470,693); nl;
  escribe llama mcd(500, 218); nl;
  escribe llama mcd(323, 323); nl;
  escribe llama mcd(369, 123); nl;
  escribe llama mcd(33, 69); nl;
 
  escribe "##### Comparacion #####"; nl;
  escribe llama comparacion(14,69); nl;
  escribe llama comparacion(50, 21); nl;
  escribe llama comparacion(32, 32); nl;
  escribe llama comparacion(36, 23); nl;
  escribe llama comparacion(33, 69); nl;
  
  escribe "##### Bits #####"; nl;
  escribe llama bits(1470); nl;
  escribe llama bits(127); nl;
  escribe llama bits(63); nl;
  escribe llama bits(31); nl;
  escribe llama bits(15); nl;

  escribe "##### Hanoi #####"; nl;  
  numero := llama hanoi(4,1,3);
  
  escribe "##### Hanoi2 #####"; nl;  
  numero := llama hanoi2(4,1,3,2);nl;  
  numero := llama hanoi2(3,1,3,2);
fin
